
import 'bunnyjs/src/polyfills/ObjectAssign';
import 'bunnyjs/src/polyfills/template';


import Emitter from "klak";

import Component from "../../src/component";
import Observer from "../../src/observer";

import {htmlToNode} from "bunnyjs/src/utils/DOM";
import { patch, text } from "incremental-dom";
import TodoListComponent from "./components/todo-list/todo-list";



const observer = Observer(document.body, { childList: true, subtree: true });

const Btn = Component({
  observer,
  tagName: 'btn',

  role: 'button',
  tabIndex: 0,

  attributes: {
    counter: { defaultValue: 0 }
  },

  connect(element) {

    console.log('Btn.connect()', element);


    element.addEventListener('click', () => {
      const state = element.state;
      state.counter++;
      element.state = state;
    });
  },

  update(element, newstate, update) {

    // console.log('Btn.update()', element);

    update(newstate, newstate.counter < 43);
  },
  render(element, state) {

    // console.log('Btn.render()', element, state);

    patch(element, () => {
      text(state.counter);
    });

  }
});


const myButton = document.createElement('btn');
const div = document.createElement('dev');

document.body.appendChild(myButton)
// myButton.appendChild(div)

myButton.setAttribute('counter', 42);

// const MyClock = Component({
//
//   tagName: 'clock',
//
//   attributes: {
//     date: { defaultValue: new Date }
//   },
//
//   connect(clock) {
//     clock._timer = setInterval(() => {
//       clock.date = new Date;
//     }, 1000);
//   },
//
//   disconnect(clock) {
//     clearInterval(clock._timer);
//   },
//
//   // set date(clock, newVal) {
//   //   clock.textContent = newVal.toLocaleTimeString();
//   // }
//
// });







const ToDo = TodoListComponent({ observer });


// document.body.appendChild(document.createElement('clock'));

