import './x-table.css';
import Component from '../../lib/component';


const arr = Array.prototype;
const slice = Array.prototype.slice;

Component({
  tag: 'sor-table',
  from: HTMLTableElement,
  options: { 'extends': 'table' },
  wasCreated(element) {

    const headings = element.querySelectorAll('[data-sort-by]');
    console.error(['sor-table'], 'wasCreated', element, headings)
    for (let th = headings, i = 0; i < th.length; i++) {
      th[i].addEventListener('click', event => {
        console.log('clicked')
        element.click(event)
      });
    }

  },
  click(self, event) {

    console.error('click')
    event.preventDefault();

    const th = event.currentTarget;
    const doc = self.ownerDocument;
    const tbody = self.querySelector('tbody');
    const order = (th.getAttribute('data-sort-order') || 'asc').toLowerCase();
    const direction = order === 'asc' ? 1 : -1;
    const columns = th.parentNode.querySelectorAll(th.nodeName);
    const index = arr.indexOf.call(columns, th);
    const sortBy = th.getAttribute('data-sort-by');
    const method = sortBy ?
        sortBy.split('.').reduce(
          function (o, m) { return o[m]; },
          doc.defaultView || doc.parentWindow
        ) :
        function (a, b) {
          return a === b ? 0 :(a < b ? -1 : 1);
        }
      ;

    slice.call(tbody.querySelectorAll('tr'), 1).sort(
      function (a, b) {
        return direction * method.call(
            self,
            a.querySelectorAll('td')[index].textContent.trim(),
            b.querySelectorAll('td')[index].textContent.trim()
          );
      }
    ).forEach(function (row) {
      this.appendChild(row);
    }, tbody);


    th.setAttribute(
      'data-sort-order',
      order === 'asc' ? 'desc' : 'asc'
    );
  },
  handleEvent(self, event) {
    return self[event.type](event);
  }
});