import 'dom4/build/dom4.max';
import 'document-register-element/build/document-register-element.max';
// import installCE from 'document-register-element/pony';


// by default, the second argument is 'auto'
// but it could be also 'force'
// which ignores feature detection and force
// the polyfill version of CustomElements
// installCE(global, 'force');
// import 'document-register-element/build/innerHTML';
import { isObject, isString, isFunction, noop, returnTrue } from './utils';




const $firstUpdate = Symbol('firstUpdate');
const $props = Symbol('props');

const Component = def => {

  isObject(def, 'definition');

  const from = isFunction(def.from) || HTMLElement;
  const tag = isString(def.tag, 'tag');
  const options = isObject(def.options) || void 0;

  def.from = null;
  def.tag = null;
  def.options = null;

  def.willUpdate = isFunction(def.willUpdate) || noop;
  def.shouldUpdate = isFunction(def.shouldUpdate) || returnTrue;
  def.wasCreated = isFunction(def.wasCreated) || noop;
  def.wasUpdated = isFunction(def.wasUpdated) || noop;
  def.wasDetached = isFunction(def.wasDetached) || noop;
  def.wasAttached = isFunction(def.wasAttached) || noop;
  def.render = isFunction(def.render) || noop;


  const reserverKeys = [
    'constructor'
  ];

  def = Object.keys(def).reduce((properties, key) => {

    if (reserverKeys.includes(key))
      return properties;

    const desc = Object.getOwnPropertyDescriptor(def, key);

    if (desc.value && isFunction(desc.value)) {
      const _function = desc.value;
      desc.value = function (...args) {
        return _function.call(this, this, ...args);
      };
    }

    properties[key] = desc;

    return properties;
  }, {});



  const Component2 = function Component() {

    console.error('constructor', this, arguments);

    // element = HTMLElement.call(this, element);
    // const element = Reflect.construct(HTMLElement, [], Component);
    const element = Reflect.construct(HTMLElement, [], Component2);

    element.wasCreated();

    return element;
  };

  // Object.assign(def, {
  //   constructor: {value: Component2, configurable: true },
  //   props: {
  //     get() {
  //       const props = this[$props];
  //
  //       console.log('[x-media-list]', 'get props', props);
  //
  //       return props;
  //     },
  //     set(newProps) {
  //
  //       console.log('[x-media-list]', 'set props', newProps)
  //
  //       this.willUpdate(newProps, this.props);
  //
  //       const componentShouldUpdate = this[$firstUpdate] || this.shouldUpdate(newProps, this.props);
  //
  //       this[$firstUpdate] = false;
  //       this[$props] = newProps;
  //
  //       if (componentShouldUpdate) {
  //         this.render(newProps);
  //         this.wasUpdated(newProps);
  //       }
  //     }
  //   }
  // });

  Component2.prototype = Object.create(HTMLElement.prototype, def);

  Component2.prototype.disconnectedCallback = function () {
    console.log(`[${tag}]`, 'disconnected');

    this.wasDetached();
  };

  Component2.prototype.connectedCallback = function () {

    console.log(`[${tag}]`, 'connected');

    // this.attachShadow({mode: 'open'});

    this[$firstUpdate] = true;
    this[$props] = null;

    // Handle lazy upgrade - take the existing props from the Element and
    // re-apply them so that they go through (and do not shadow) the setter.
    const props = this.props;
    if (props) {
      delete this.props;
      this.props = props;
    }

    this.wasAttached(props);
  };

  Component2.prototype.attributeChangedCallback = function (...args) {

    console.log(`[${tag}]`, 'attributeChanged');

  };

  // Component.prototype = Object.create(
  //   from.prototype,
  //   def
  // );

  const CustomElement = function (...args) {

    console.log('Component()', args);
    // const element = from.call(this);
    const element = Reflect.construct(from, [], CustomElement);

    element.wasCreated(element);

    return element;
  };


  CustomElement.prototype = Object.create(from.prototype, {
    ...def,
    constructor: {value: CustomElement, configurable: true },
    props: {
      get() {
        const props = this[$props];

        console.log('[x-media-list]', 'get props', props);

        return props;
      },
      set(newProps) {

        console.log('[x-media-list]', 'set props', newProps);

        const props = this.props;

        this.willUpdate(newProps, props);

        const componentShouldUpdate = this.shouldUpdate(newProps, props);

        this[$props] = newProps;

        if (componentShouldUpdate) {
          this.render(newProps);
          this.wasUpdated(newProps);
        }
      }
    },
    connectedCallback: {value: function (...args) {

      console.log('Component', 'connected', args);

      // Handle lazy upgrade - take the existing props from the Element and
      // re-apply them so that they go through (and do not shadow) the setter.
      const props = this.props;
      if (props) {
        delete this.props;
        this.props = props;
      }

      this.wasAttached();

    }},
    disconnectedCallback: {value: function (...args) {

      console.log(`[${tag}]`, 'disconnected');

      this.wasDetached();
    }},
  });


  customElements.define(
    tag,
    CustomElement
  );

  return def;
};

export default Component;