import {
  patch,
  elementOpen,
  elementVoid,
  elementClose,
  text
} from 'incremental-dom';

import {
  before
} from './utils';



// The root container needs to be manually created when using the
// web components polyfill.

const existingContainer = document.getElementById('container');
const container = document.createElement('div');

existingContainer.parentNode.replaceChild(container, existingContainer);





const update = data => {

  patch(container, () => {
    data.items.forEach((item, index) => {

      elementOpen('x-item', index, null, 'data-selected', index === data.selectedIndex, 'props', {
        text: item
      });
      elementClose('x-item');
    });

    elementOpen('div', null, null, 'style', 'position: absolute; top: 0; right: 0;');
    text('calls to x-item\'s render: ' + data.itemRenderCount);
    elementClose('div');
  });
};

// Updates the selected index, the text of the zero-th item and rerenders every second
let updateCount = 0;
const items = ['update #0', 'first', 'second', 'third', 'fourth'];
let itemRenderCount = 0;

before(Item.prototype, 'render', function () {
  itemRenderCount += 1;
});

setInterval(() => {

  updateCount += 1;
  const selectedIndex = (updateCount + 1) % items.length;

  items[0] = 'update #' + updateCount;

  update({
    items: items,
    selectedIndex: selectedIndex,
    itemRenderCount: itemRenderCount
  });

}, 1000);

update({
  items: items,
  selectedIndex: 1
});
