import {
  patch,
  elementVoid
} from 'incremental-dom';
import {
  isRequired,
  isString
} from '../utils';

const PwetDirective = () => (scope, element) => {

  const isAttribute = input => input !== 'tag' && !input.startsWith('$');

  const tag = scope.$resolve && scope.$resolve.tag;

  isRequired(tag, 'tag');
  isString(tag, 'tag');

  const attrs = Object.keys(scope.$resolve).filter(isAttribute).reduce((data, key) => {

    return Object.assign(data, { [key]: scope.$resolve[key] });
  }, {});

  const container = document.createElement('div');

  patch(container, () => {
    elementVoid(tag);
  });

  element.replaceWith(container.querySelector(tag));

  patch(container, () => {
    elementVoid(tag, null, null, 'props', attrs);
  });
};

export default PwetDirective;